library ieee;

use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;
use ieee.numeric_std.all;

ENTITY VGA IS
PORT(
SW:IN STD_LOGIC_VECTOR(9 downto 0);
OE,WR_N:OUT STD_LOGIC;
KEY:IN STD_LOGIC_VECTOR(3 downto 0);
LEDG:OUT STD_LOGIC_VECTOR(7 downto 0);
SRAM_ADDR: OUT STD_LOGIC_VECTOR(17 downto 0);
SRAM_CE_N:OUT STD_LOGIC;
SRAM_DQ:INOUT STD_LOGIC_VECTOR(15 downto 0);
SRAM_OE_N:OUT STD_LOGIC;
SRAM_WE_N:OUT STD_LOGIC;
ADC_CLK:out STD_LOGIC;
ADIN :IN STD_LOGIC_VECTOR(7 downto 0);
VGA_R,VGA_B,VGA_G:OUT STD_LOGIC_VECTOR(3 downto 0);
VGA_HS,VGA_VS:OUT STD_LOGIC;
CLK,CLK27:IN STD_LOGIC;
TRIGGERR:IN STD_LOGIC;
TESTPIN:OUT STD_LOGIC
);
END VGA;

ARCHITECTURE  VGA OF VGA IS
SIGNAL AREAD: STD_LOGIC_VECTOR(17 downto 0);
SIGNAL RDY: STD_LOGIC;

 SIGNAL RST: STD_LOGIC;
signal reset:STD_LOGIC;
SIGNAL PLL_CLK:STD_LOGIC;--CLK für VGA , 80 MHZ 
 COMPONENT ccd IS 
PORT(
CLK:IN STD_LOGIC;
SRAM_ADDR: OUT STD_LOGIC_VECTOR(17 downto 0);
SRAM_CE_N:OUT STD_LOGIC;
SRAM_DQ:INOUT STD_LOGIC_VECTOR(15 downto 0);
SRAM_OE_N:OUT STD_LOGIC;
SRAM_WE_N:OUT STD_LOGIC;
ADC_CLK:out STD_LOGIC;
ADIN :IN STD_LOGIC_VECTOR(7 downto 0);
RST:IN STD_LOGIC;
AREAD: IN STD_LOGIC_VECTOR(17 downto 0);
RDY:inOUT STD_LOGIC;
SWI:IN STD_LOGIC_VECTOR(9 downto 0);
TEST:OUT STD_LOGIC
	 );
	 end component ccd;
	 
	 
	 
 COMPONENT pll IS
        PORT (
            pll_c0_clk : out std_logic;        -- clk
           pll_inclk_interface_reset_reset  : in  std_logic; -- clk
             pll_inclk_interface_clk  : in  std_logic   -- reset
       );
   END COMPONENT pll;
 BEGIN
 OE<='0';
 WR_N<='0';
u1: CCD port map(
CLK27,
SRAM_ADDR,
SRAM_CE_N,
SRAM_DQ,
SRAM_OE_N,
SRAM_WE_N,
ADC_CLK,
ADIN,
RST,
AREAD,
RDY,
SW,
TESTPIN
);
u0 :  pll
        port map (
             PLL_CLK, -- clkout.clk
             reset,  --  clkin.clk
             CLK   --    rst.reset
        );


PROCESS(PLL_CLK)
VARIABLE ADDR1: STD_LOGIC_VECTOR(17 downto 0):=(others=>'0');--FÜR  ODD-LINIEN
VARIABLE ADDR2: STD_LOGIC_VECTOR(17 downto 0):="010111100110000111";--FÜR EVEN-LINIEN
VARIABLE Pix:INTEGER RANGE 0 to 1800:=0;
VARIABLE FLAG: STD_LOGIC:='0';
VARIABLE Lines : INTEGER RANGE 0 to 1100:=0;
VARIABLE GO:STD_LOGIC:='0';---'1' wenn ein Bild vollständig gelesen wurde
VARIABLE ODD:STD_LOGIC:='0';---FLAG für ODD/EVEN
VARIABLE DATA:STD_LOGIC_VECTOR(3 downto 0);
BEGIN
IF(PLL_CLK'EVENT AND PLL_CLK='1')THEN



IF(Lines=0 AND RDY='1')THEN---falls ein Bild direkt nach Display refresh fertig ist, dann lese das Bild aus
GO:='1';
ELSIF(Lines=0 AND RDY='0')THEN
GO:='0';--sonst warte 
END IF;

IF(Lines=650 AND  GO='1' AND RST='0')THEN
RST<='1';--Nach dam das Bild wiedergegeben wurde, mach reset!
ADDR1:=(others=>'0');
ADDR2:="010111100110000111";
ELSE
RST<='0';
END IF;
Pix:=Pix+1;
IF(0<Pix AND Pix<1280)THEN
IF(Pix<882 AND Pix>305 AND Lines <650 AND Lines>(100) AND GO='1' )THEN--eigentliche Bildwiedergabe
IF(FLAG='0')THEN
FLAG:='1';
VGA_B<=SRAM_DQ(7 downto 4);
VGA_G<=SRAM_DQ(7 downto 4);
VGA_R<=SRAM_DQ(7 downto 4);
ELSE
FLAG:='0';
VGA_B<=SRAM_DQ(3 downto 0);
VGA_G<=SRAM_DQ(3 downto 0);
VGA_R<=SRAM_DQ(3 downto 0);
IF(ODD='1')THEN
ADDR1:= ADDR1+1;
AREAD<=ADDR1;
ELSE
ADDR2:= ADDR2+1;
AREAD<=ADDR2;
END IF;
END IF;
ELSE
VGA_R<="0000";
VGA_G<="0000";
VGA_B<="0000";
END IF;
VGA_HS<='1';
ELSE
VGA_R<="0000";
VGA_G<="0000";
VGA_B<="0000";
VGA_HS<='0';
END IF;
IF(0<Lines AND Lines<1024)THEN
VGA_VS<='1';
ELSIF(Lines =1025)THEN
VGA_VS<='0';
ELSE
VGA_VS<='0';

END IF;
IF(Pix=1300)THEN
ODD:=NOT ODD;
Pix:=0;
Lines:=Lines+1;
IF (Lines=1045)THEN
Lines:=0;
END IF;
END IF;
END IF;
END PROCESS;
END VGA;