library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;
use ieee.numeric_std.all;
use work.my.all;

ENTITY CCD IS
PORT (
CLK:IN STD_LOGIC;
SRAM_ADDR: OUT STD_LOGIC_VECTOR(17 downto 0);
SRAM_CE_N:OUT STD_LOGIC;
SRAM_DQ:INOUT STD_LOGIC_VECTOR(15 downto 0);
SRAM_OE_N:OUT STD_LOGIC;
SRAM_WE_N:OUT STD_LOGIC;
ADC_CLK:out STD_LOGIC;
ADIN :IN STD_LOGIC_VECTOR(7 downto 0);
RST:IN STD_LOGIC;
AREAD:IN STD_LOGIC_VECTOR(17 downto 0);
RDY :inOUT STD_LOGIC;
SWI:IN STD_LOGIC_VECTOR(9 downto 0);
TEST:OUT STD_LOGIC
);
END CCD;

ARCHITECTURE GETIMG OF CCD IS
COMPONENT PAT IS
PORT(
PIN:IN STD_LOGIC;
CLK:IN STD_LOGIC;
OUTPUT:OUT PATTERN
);
END COMPONENT PAT;
SIGNAL DET:PATTERN;
SIGNAL CNT :STD_LOGIC:='0';
SIGNAL ADDR: STD_LOGIC_VECTOR(17 downto 0):=(others=>'0');
SIGNAL PWMIN: STD_LOGIC;
BEGIN
u2: PAT PORT MAP(ADIN(7),PWMIN,DET);
SRAM_CE_N<='0';
ADC_CLK<=CLK;---CLK FÜR AD-WANDLER (30 MHz MAX)
PWMIN<=CLK;---CLK FÜR MUSTERERKENNUNG-KOMPONENT
WITH ADDR SELECT
RDY<='1' WHEN "110111100110000111",---Ready wenn diese adresse erreicht ist
     '0' WHEN OTHERS;
PROCESS(CLK)
VARIABLE COUNTER : INTEGER RANGE 0 to 50:=0;
VARIABLE COUNTER2 : INTEGER RANGE 0 to 50:=0;
VARIABLE FIELD: STD_LOGIC:='0';---odd oder even
VARIABLE FLAG: STD_LOGIC:='0';
VARIABLE START_1:STD_LOGIC:='0';---starte lesevorgang für start_1='1'

BEGIN
IF(CLK'EVENT and CLK='0')THEN

IF(RST='1')THEN---RESET INSTRUCTION
FIELD:='0';
TEST<='0';
START_1:='0';
ADDR<=(others=>'0');
END IF;

COUNTER2:=COUNTER2+1;
COUNTER:=COUNTER+1;


IF (ADDR<"110111100110000111")THEN


IF(ADDR="010111100110000111")THEN---sobald alle ODD-Linien gelesesen sind, warte auf EVEN-TRIGGER
FIELD:='1';
START_1:='0';
END IF;
IF (COUNTER =3)THEN
COUNTER:=0;

IF(DET(0)=5 AND DET(1)=4 AND DET(2)=17 AND START_1='0' AND FIELD='0' )THEN---TRIGGER FÜR ODD
START_1:='1';
ELSIF (DET(0)=5 AND DET(1)=5 AND DET(2)=17 AND START_1='0' AND FIELD='1')THEN---TRIGGER FÜR EVEN
START_1:='1';
TEST<='1';
END IF;

IF(START_1='1')THEN
SRAM_WE_N<='0';--WRITE-MODE
SRAM_OE_N<='1';
IF (FLAG='0')THEN
FLAG:='1';
SRAM_DQ(7 downto 4)<=ADIN(6 downto 3);
ELSE 
FLAG :='0';
SRAM_DQ(3 downto 0)<=ADIN(6 downto 3);
ADDR<= ADDR+1;
SRAM_ADDR<= ADDR;
END IF;
END IF;
END IF;
ELSE 
SRAM_ADDR<=AREAD;
SRAM_WE_N<='1';---WENN READY=>READ MODE
SRAM_OE_N<='0';
SRAM_DQ<=(others=>'Z');
END IF;
END IF;
END PROCESS;
END GETIMG;

